﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private working As Boolean = True
	Public mqtt As MqttClient
	Public  torreout As String = "AV/OUT"
	Public  torrein As String = "AV/IN"
	Private servidor As String = "tcp://test.mosquitto.org:1883"  
	Public idclient As String
	Public estado As String ="Disconnected"
	Private username As String = ""
	Private password As String = ""
	Public incoming As String=""
End Sub

Sub Service_Create
	working = True
	Dim r As Reflector
	idclient= "A-" & r.GetStaticField("android.os.Build", "SERIAL")  'GET A UNIQUE ID FOR THIS ANDROID DEVICE
	mqtt.Initialize("mqtt", servidor , idclient)
	ConnectAndReconnect
End Sub


Sub ConnectAndReconnect
	Do While working
		If mqtt.IsInitialized Then mqtt.Close
		mqtt.Initialize("mqtt", servidor, idclient)
		Dim mo As MqttConnectOptions
		mo.Initialize(username, password)
		estado = "Conecting ..."
		mqtt.Connect2(mo)
		Wait For Mqtt_Connected (Success As Boolean)
		If Success Then
			estado="Conected"
			AfterConnect
			Do While working And mqtt.Connected
				
				'mqtt.Publish2($"${username}/f/ping"$, Array As Byte(0), 1, False)
				Sleep(5000)
			Loop
			estado =  "Disconnected"
		Else
			estado ="Error connecting"
		End If
		UpdateState
		Sleep(5000)
	Loop
End Sub

Private Sub AfterConnect
	mqtt.Subscribe(torreout, 0)
	UpdateState
End Sub

Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	incoming = BytesToString(Payload, 0, Payload.Length, "ascii")
	UpdateState
End Sub

Sub UpdateState
	CallSub(Main, "SetState")
End Sub



Sub Service_Start (StartingIntent As Intent)
	

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
